## linux-ppc 3.8.0-4.8

=== arch/powerpc/platforms/85xx/Makefile ===
#
# Makefile for the PowerPC 85xx linux kernel.
#
obj-$(CONFIG_SMP) += smp.o

obj-y += common.o

obj-$(CONFIG_BSC9131_RDB) += bsc913x_rdb.o
obj-$(CONFIG_MPC8540_ADS) += mpc85xx_ads.o
obj-$(CONFIG_MPC8560_ADS) += mpc85xx_ads.o
obj-$(CONFIG_MPC85xx_CDS) += mpc85xx_cds.o
obj-$(CONFIG_MPC8536_DS)  += mpc8536_ds.o
obj-$(CONFIG_MPC85xx_DS)  += mpc85xx_ds.o
obj-$(CONFIG_MPC85xx_MDS) += mpc85xx_mds.o
obj-$(CONFIG_MPC85xx_RDB) += mpc85xx_rdb.o
obj-$(CONFIG_P1010_RDB)   += p1010rdb.o
obj-$(CONFIG_P1022_DS)    += p1022_ds.o
obj-$(CONFIG_P1022_RDK)   += p1022_rdk.o
obj-$(CONFIG_P1023_RDS)   += p1023_rds.o
obj-$(CONFIG_P2041_RDB)   += p2041_rdb.o corenet_ds.o
obj-$(CONFIG_P3041_DS)    += p3041_ds.o corenet_ds.o
obj-$(CONFIG_P4080_DS)    += p4080_ds.o corenet_ds.o
obj-$(CONFIG_P5020_DS)    += p5020_ds.o corenet_ds.o
obj-$(CONFIG_P5040_DS)    += p5040_ds.o corenet_ds.o
obj-$(CONFIG_FSL_P4080_DS_MDIO) += p4080_ds_mdio.o
obj-$(CONFIG_STX_GP3)	  += stx_gp3.o
obj-$(CONFIG_TQM85xx)	  += tqm85xx.o
obj-$(CONFIG_SBC8548)     += sbc8548.o
obj-$(CONFIG_SOCRATES)    += socrates.o socrates_fpga_pic.o
obj-$(CONFIG_KSI8560)	  += ksi8560.o
obj-$(CONFIG_XES_MPC85xx) += xes_mpc85xx.o
obj-$(CONFIG_GE_IMP3A)	  += ge_imp3a.o
obj-$(CONFIG_PPC_QEMU_E500) += qemu_e500.o
obj-$(CONFIG_SGY_CTS1000) += sgy_cts1000.o

=== drivers/net/dpa/NetCommSw/etc/Makefile ===
#
# Makefile for the Freescale Ethernet controllers
#
EXTRA_CFLAGS           += -DVERSION=\"\"
#
#Include netcomm SW specific definitions
include $(srctree)/drivers/net/dpa/NetCommSw/ncsw_config.mk

obj-y		+= fsl-ncsw-etc.o

fsl-ncsw-etc-objs	:= mm.o memcpy.o sprint.o list.o error.o

=== drivers/net/dpa/NetCommSw/Peripherals/FM/Makefile ===
#
# Makefile for the Freescale Ethernet controllers
#
EXTRA_CFLAGS           += -DVERSION=\"\"
#
#Include netcomm SW specific definitions
include $(srctree)/drivers/net/dpa/NetCommSw/ncsw_config.mk
NCSW_FM_INC = $(srctree)/drivers/net/dpa/NetCommSw/Peripherals/FM/inc

EXTRA_CFLAGS += -I$(NCSW_FM_INC)


obj-y		+= fsl-ncsw-PFM1.o

fsl-ncsw-PFM1-objs	:=   fm.o fm_muram.o

obj-y		+= MAC/
obj-y		+= Pcd/
obj-y		+= Port/
obj-y		+= HC/
obj-y		+= Rtc/

=== drivers/net/dpa/NetCommSw/src/xx/Makefile ===
#
# Makefile for the Freescale Ethernet controllers
#
EXTRA_CFLAGS           += -DVERSION=\"\"
#
#Include netcomm SW specific definitions
include $(srctree)/drivers/net/dpa/NetCommSw/ncsw_config.mk

obj-y		+= fsl-ncsw-xx.o

fsl-ncsw-xx-objs	:=   xx_linux.o udivdi3.o stdlib.o

=== drivers/net/dpa/NetCommSw/Peripherals/FM/Port/Makefile ===
#
# Makefile for the Freescale Ethernet controllers
#
EXTRA_CFLAGS           += -DVERSION=\"\"
#
#Include netcomm SW specific definitions
include $(srctree)/drivers/net/dpa/NetCommSw/ncsw_config.mk

NCSW_FM_INC = $(srctree)/drivers/net/dpa/NetCommSw/Peripherals/FM/inc

EXTRA_CFLAGS += -I$(NCSW_FM_INC)

obj-y		+= fsl-ncsw-Pcd.o

fsl-ncsw-Pcd-objs	:=   fm_port.o fm_port_im.o

=== drivers/net/dpa/NetCommSw/Peripherals/FM/Rtc/Makefile ===
#
# Makefile for the Freescale Ethernet controllers
#
EXTRA_CFLAGS           += -DVERSION=\"\"
#
#Include netcomm SW specific definitions
include $(srctree)/drivers/net/dpa/NetCommSw/ncsw_config.mk

NCSW_FM_INC = $(srctree)/drivers/net/dpa/NetCommSw/Peripherals/FM/inc

EXTRA_CFLAGS += -I$(NCSW_FM_INC)

obj-y		+= fsl-ncsw-RTC.o

fsl-ncsw-RTC-objs	:=   fm_rtc.o

=== debian/changelog ===
linux-ppc (3.8.0-4.8) raring; urgency=low

  [ Ubuntu: 3.8.0-6.11 ]

  * Release Tracking Bug
    - LP: #1122071
  * rebase to v3.8-rc7
  * Add libaudit-dev as a build dependency
  * Build perf with NO_LIBPYTHON=1 to avoid a python build dependency.
  * [Config] Remove CONFIG_SATA_AHCI annotation

  [ Ubuntu: 3.8.0-5.10 ]

  * Release Tracking Bug
    - LP: #1118568
  * Bump ABI to fix install issue with 3.8.0-4.8.
    Moving drivers/ata/*ahci* to linux-image caused an
    install conflict with linux-image-extras without an
    ABI bump.
  * SAUCE: xen-pciback: rate limit error messages from
    xen_pcibk_enable_msi{, x}()
    - LP: #1117336
    - CVE-2013-0231

  [ Ubuntu: 3.8.0-4.9 ]

  * d-i: Add mellanox ethernet drivers to nic-modules
    - LP: #1015339
  * SAUCE: ACPI: Add DMI entry for Sony VGN-FW41E_H
    - LP: #1113547
  * SAUCE: alx driver import script
  * SAUCE: alx: Update to heads/master
  * Release Tracking Bug
    - LP: #1117673
  * [debian] Remove dangling symlink from headers package
    - LP: #1112442
  * [config] CONFIG_ALX=m
  * [Config] Add alx to d-i nic-modules
  * [Config] CONFIG_SATA_AHCI=m
    - LP: #1056563

 -- Ben Collins <ben.c@servergy.com>  Wed, 13 Feb 2013 09:01:48 -0500

=== debian/control ===
Source: linux-ppc
Section: devel
Priority: optional
Maintainer: Ubuntu Kernel Team <kernel-team@lists.ubuntu.com>
Standards-Version: 3.8.4.0
Build-Depends: debhelper (>= 5), cpio, module-init-tools, kernel-wedge (>= 2.24ubuntu1), device-tree-compiler [powerpc], libelf-dev, libnewt-dev, binutils-dev, rsync, libdw-dev, dpkg (>= 1.16.0~ubuntu4), util-linux, pkg-config, flex, bison, libunwind8-dev, openssl, u-boot-tools [powerpc]
Build-Depends-Indep: xmlto, docbook-utils, ghostscript, transfig, bzip2, sharutils, asciidoc
Build-Conflicts: findutils (= 4.4.1-1ubuntu1)
Vcs-Git: http://kernel.ubuntu.com/git-repos/ubuntu/ubuntu-raring.git

Package: linux-ppc-source-3.8.0
Architecture: all
Section: devel
Priority: optional
Provides: linux-ppc-source, linux-ppc-source-3
Depends: ${misc:Depends}, binutils, bzip2, coreutils | fileutils (>= 4.0)
Recommends: libc-dev, gcc, make
Suggests: libncurses-dev | ncurses-dev, kernel-package, libqt3-dev
Description: Linux kernel source for version 3.8.0 with Ubuntu patches
 This package provides the source code for the Linux kernel version
 3.8.0.
 .
 This package is mainly meant for other packages to use, in order to build
 custom flavours.
 .
 If you wish to use this package to create a custom Linux kernel, then it
 is suggested that you investigate the package kernel-package, which has
 been designed to ease the task of creating kernel image packages.
 .
 If you are simply trying to build third-party modules for your kernel,
 you do not want this package. Install the appropriate linux-headers
 package instead.

Package: linux-ppc-doc
Architecture: all
Section: doc
Priority: optional
Depends: ${misc:Depends}
Conflicts: linux-ppc-doc-3
Replaces: linux-ppc-doc-3
Description: Linux kernel specific documentation for version 3.8.0
 This package provides the various documents in the 3.8.0 kernel
 Documentation/ subdirectory.  These document kernel subsystems, APIs, device
 drivers, and so on.  See
 /usr/share/doc/linux-ppc-doc/00-INDEX for a list of what is
 contained in each file.

Package: linux-ppc-tools-common
Architecture: all
Section: kernel
Priority: optional
Depends: ${misc:Depends}
Replaces: linux-ppc-tools (<= 2.6.32-16.25)
Description: Linux kernel version specific tools for version 3.8.0
 This package provides the architecture independent parts for kernel
 version locked tools (such as perf and x86_energy_perf_policy) for
 version PGKVER.

Package: linux-ppc-headers-3.8.0-4
Architecture: powerpc
Section: devel
Priority: optional
Depends: ${misc:Depends}, coreutils | fileutils (>= 4.0)
Description: Header files related to Linux kernel version 3.8.0
 This package provides kernel header files for version 3.8.0, for sites
 that want the latest kernel headers. Please read
 /usr/share/doc/linux-ppc-headers-3.8.0-4/debian.README.gz for details

Package: linux-ppc-tools-3.8.0-4
Architecture: powerpc
Section: devel
Priority: optional
Depends: ${misc:Depends}, ${shlibs:Depends}, linux-ppc-tools-common
Description: Linux kernel version specific tools for version 3.8.0-4
 This package provides the architecture dependant parts for kernel
 version locked tools (such as perf and x86_energy_perf_policy) for
 version 3.8.0-4 on
 PowerPC (32 bit userspace).


Package: linux-image-3.8.0-4-powerpc-e500
Architecture: powerpc
Section: kernel
Priority: optional
Pre-Depends: dpkg (>= 1.10.24)
Provides: linux-image, linux-image-3.0, fuse-module, redhat-cluster-modules, ivtv-modules
Depends: ${misc:Depends}, ${shlibs:Depends}, initramfs-tools (>= 0.36ubuntu6), module-init-tools (>= 3.3-pre11-4ubuntu3)
Conflicts: hotplug (<< 0.0.20040105-1)
Recommends: grub-kexec
Suggests: fdutils, linux-ppc-doc-3.8.0 | linux-ppc-source-3.8.0, linux-ppc-tools, linux-headers-3.8.0-4-powerpc-e500
Description: Linux kernel image for version 3.8.0 on 32-bit Freescale Power e500v1 and e500v2
 This package contains the Linux kernel image for version 3.8.0 on
 32-bit Freescale Power e500v1 and e500v2.
 .
 Also includes the corresponding System.map file, the modules built by the
 packager, and scripts that try to ensure that the system is not left in an
 unbootable state after an update.
 .
 Supports 32-bit Freescale Power e500v1 and e500v2 processors.
 .
 Geared toward server systems.
 .
 You likely do not want to install this package directly. Instead, install
 the linux-powerpc-e500 meta-package, which will ensure that upgrades work
 correctly, and that supporting packages are also installed.

Package: linux-image-extra-3.8.0-4-powerpc-e500
Architecture: powerpc
Section: kernel
Priority: optional
Depends: ${misc:Depends}, ${shlibs:Depends}, linux-image-3.8.0-4-powerpc-e500, crda (>=1.1.1-1ubuntu2) | wireless-crda
Description: Linux kernel image for version 3.8.0 on 32-bit Freescale Power e500v1 and e500v2
 This package contains the Linux kernel image for version 3.8.0 on
 32-bit Freescale Power e500v1 and e500v2.
 .
 Also includes the corresponding System.map file, the modules built by the
 packager, and scripts that try to ensure that the system is not left in an
 unbootable state after an update.
 .
 Supports 32-bit Freescale Power e500v1 and e500v2 processors.
 .
 Geared toward server systems.
 .
 You likely do not want to install this package directly. Instead, install
 the linux-powerpc-e500 meta-package, which will ensure that upgrades work
 correctly, and that supporting packages are also installed.

Package: linux-headers-3.8.0-4-powerpc-e500
Architecture: powerpc
Section: devel
Priority: optional
Depends: ${misc:Depends}, linux-ppc-headers-3.8.0-4, ${shlibs:Depends}
Provides: linux-headers, linux-headers-3.0
Description: Linux kernel headers for version 3.8.0 on 32-bit Freescale Power e500v1 and e500v2
 This package provides kernel header files for version 3.8.0 on
 32-bit Freescale Power e500v1 and e500v2.
 .
 This is for sites that want the latest kernel headers.  Please read
 /usr/share/doc/linux-ppc-headers-3.8.0-4/debian.README.gz for details.

Package: linux-image-3.8.0-4-powerpc-e500-dbgsym
Architecture: powerpc
Section: devel
Priority: optional
Depends: ${misc:Depends}
Provides: linux-debug
Description: Linux kernel debug image for version 3.8.0 on 32-bit Freescale Power e500v1 and e500v2
 This package provides a kernel debug image for version 3.8.0 on
 32-bit Freescale Power e500v1 and e500v2.
 .
 This is for sites that wish to debug the kernel.
 .
 The kernel image contained in this package is NOT meant to boot from. It
 is uncompressed, and unstripped. This package also includes the
 unstripped modules.

Package: linux-image-3.8.0-4-powerpc-e500mc
Architecture: powerpc
Section: kernel
Priority: optional
Pre-Depends: dpkg (>= 1.10.24)
Provides: linux-image, linux-image-3.0, fuse-module, redhat-cluster-modules, ivtv-modules
Depends: ${misc:Depends}, ${shlibs:Depends}, initramfs-tools (>= 0.36ubuntu6), module-init-tools (>= 3.3-pre11-4ubuntu3)
Conflicts: hotplug (<< 0.0.20040105-1)
Recommends: grub-kexec
Suggests: fdutils, linux-ppc-doc-3.8.0 | linux-ppc-source-3.8.0, linux-ppc-tools, linux-headers-3.8.0-4-powerpc-e500mc
Description: Linux kernel image for version 3.8.0 on 32-bit Freescale Power e500mc
 This package contains the Linux kernel image for version 3.8.0 on
 32-bit Freescale Power e500mc.
 .
 Also includes the corresponding System.map file, the modules built by the
 packager, and scripts that try to ensure that the system is not left in an
 unbootable state after an update.
 .
 Supports 32-bit Freescale Power e500mc processors.
 .
 Geared toward server systems.
 .
 You likely do not want to install this package directly. Instead, install
 the linux-powerpc-e500mc meta-package, which will ensure that upgrades work
 correctly, and that supporting packages are also installed.

Package: linux-image-extra-3.8.0-4-powerpc-e500mc
Architecture: powerpc
Section: kernel
Priority: optional
Depends: ${misc:Depends}, ${shlibs:Depends}, linux-image-3.8.0-4-powerpc-e500mc, crda (>=1.1.1-1ubuntu2) | wireless-crda
Description: Linux kernel image for version 3.8.0 on 32-bit Freescale Power e500mc
 This package contains the Linux kernel image for version 3.8.0 on
 32-bit Freescale Power e500mc.
 .
 Also includes the corresponding System.map file, the modules built by the
 packager, and scripts that try to ensure that the system is not left in an
 unbootable state after an update.
 .
 Supports 32-bit Freescale Power e500mc processors.
 .
 Geared toward server systems.
 .
 You likely do not want to install this package directly. Instead, install
 the linux-powerpc-e500mc meta-package, which will ensure that upgrades work
 correctly, and that supporting packages are also installed.

Package: linux-headers-3.8.0-4-powerpc-e500mc
Architecture: powerpc
Section: devel
Priority: optional
Depends: ${misc:Depends}, linux-ppc-headers-3.8.0-4, ${shlibs:Depends}
Provides: linux-headers, linux-headers-3.0
Description: Linux kernel headers for version 3.8.0 on 32-bit Freescale Power e500mc
 This package provides kernel header files for version 3.8.0 on
 32-bit Freescale Power e500mc.
 .
 This is for sites that want the latest kernel headers.  Please read
 /usr/share/doc/linux-ppc-headers-3.8.0-4/debian.README.gz for details.

Package: linux-image-3.8.0-4-powerpc-e500mc-dbgsym
Architecture: powerpc
Section: devel
Priority: optional
Depends: ${misc:Depends}
Provides: linux-debug
Description: Linux kernel debug image for version 3.8.0 on 32-bit Freescale Power e500mc
 This package provides a kernel debug image for version 3.8.0 on
 32-bit Freescale Power e500mc.
 .
 This is for sites that wish to debug the kernel.
 .
 The kernel image contained in this package is NOT meant to boot from. It
 is uncompressed, and unstripped. This package also includes the
 unstripped modules.

Package: linux-image-3.8.0-4-powerpc-smp
Architecture: powerpc
Section: kernel
Priority: optional
Pre-Depends: dpkg (>= 1.10.24)
Provides: linux-image, linux-image-3.0, fuse-module, redhat-cluster-modules, ivtv-modules
Depends: ${misc:Depends}, ${shlibs:Depends}, initramfs-tools (>= 0.36ubuntu6), module-init-tools (>= 3.3-pre11-4ubuntu3)
Conflicts: hotplug (<< 0.0.20040105-1)
Recommends: yaboot
Suggests: fdutils, linux-ppc-doc-3.8.0 | linux-ppc-source-3.8.0, linux-ppc-tools, linux-headers-3.8.0-4-powerpc-smp
Description: Linux kernel image for version 3.8.0 on 32-bit PowerPC SMP
 This package contains the Linux kernel image for version 3.8.0 on
 32-bit PowerPC SMP.
 .
 Also includes the corresponding System.map file, the modules built by the
 packager, and scripts that try to ensure that the system is not left in an
 unbootable state after an update.
 .
 Supports 32-bit PowerPC SMP processors.
 .
 Geared toward desktop or server systems.
 .
 You likely do not want to install this package directly. Instead, install
 the linux-powerpc-smp meta-package, which will ensure that upgrades work
 correctly, and that supporting packages are also installed.

Package: linux-image-extra-3.8.0-4-powerpc-smp
Architecture: powerpc
Section: kernel
Priority: optional
Depends: ${misc:Depends}, ${shlibs:Depends}, linux-image-3.8.0-4-powerpc-smp, crda (>=1.1.1-1ubuntu2) | wireless-crda
Description: Linux kernel image for version 3.8.0 on 32-bit PowerPC SMP
 This package contains the Linux kernel image for version 3.8.0 on
 32-bit PowerPC SMP.
 .
 Also includes the corresponding System.map file, the modules built by the
 packager, and scripts that try to ensure that the system is not left in an
 unbootable state after an update.
 .
 Supports 32-bit PowerPC SMP processors.
 .
 Geared toward desktop or server systems.
 .
 You likely do not want to install this package directly. Instead, install
 the linux-powerpc-smp meta-package, which will ensure that upgrades work
 correctly, and that supporting packages are also installed.

Package: linux-headers-3.8.0-4-powerpc-smp
Architecture: powerpc
Section: devel
Priority: optional
Depends: ${misc:Depends}, linux-ppc-headers-3.8.0-4, ${shlibs:Depends}
Provides: linux-headers, linux-headers-3.0

=== debian/rules ===
#!/usr/bin/make -f
#
# $(DEBIAN)/rules for Ubuntu linux
#
# Use this however you want, just give credit where credit is due.
#
# Copyright (c) 2007 Ben Collins <bcollins@ubuntu.com>
#

DEBIAN=$(shell awk -F= '($$1 == "DEBIAN") { print $$2 }' <debian/debian.env)

# dpkg-buildpackage passes options that are incomptatible
# with the kernel build.
unexport CFLAGS
unexport LDFLAGS

export LC_ALL=C
export SHELL=/bin/bash -e

# Where do we find the common configuration.
export DROOT=debian

# Common variables for all architectures
include $(DROOT)/rules.d/0-common-vars.mk

# Pull in some arch specific stuff
-include $(DEBIAN)/rules.d/$(arch).mk

# Maintainer targets
include $(DROOT)/rules.d/1-maintainer.mk

# Stages -- support both DEB_STAGE=stage1 and DEB_BUILD_PROFILE=bootstrap
ifeq ($(DEB_STAGE),stage1)
    DEB_BUILD_PROFILE=bootstrap
endif
ifeq ($(DEB_BUILD_PROFILE),bootstrap)
    do_tools=false
    do_doc_package=false
    do_source_package=false
    do_flavour_image_package=false
    do_flavour_header_package=false
endif

# autopkgtest -- rebuild support
#  only build the first flavour on the assumption it is representative
ifeq ($(DEB_BUILD_PROFILE),autopkgtest)
flavours := $(firstword $(flavours))
endif

# Debian Build System targets
binary: binary-indep binary-arch

build: build-arch build-indep

clean: debian/control
	dh_testdir
	dh_testroot
	dh_clean

	# d-i stuff
	rm -rf debian/d-i-$(arch)

	# normal build junk
	rm -rf $(DEBIAN)/abi/$(release)-$(revision)
	rm -rf $(builddir)
	rm -f $(stampdir)/stamp-*
	rm -rf $(DEBIAN)/linux-*

	# This gets rid of the d-i packages in control
	cp -f $(DEBIAN)/control.stub $(DEBIAN)/control
	cp $(DEBIAN)/changelog debian/changelog

	# Install the copyright information.
	cp $(DEBIAN)/copyright debian/copyright

distclean: clean
	rm -rf $(DEBIAN)/control $(DEBIAN)/control.stub \
		$(DEBIAN)/d-i/kernel-versions debian/changelog \
		debian/control debian/control.stub debian/copyright

# Builds the image, arch headers and debug packages
include $(DROOT)/rules.d/2-binary-arch.mk

# Rules for building the udebs ($(DEBIAN)-installer)
include $(DROOT)/rules.d/5-udebs.mk

# Builds the source, doc and linux-headers indep packages
include $(DROOT)/rules.d/3-binary-indep.mk

# Various checks to be performed on builds
include $(DROOT)/rules.d/4-checks.mk

# Misc stuff
.PHONY: $(DEBIAN)/control.stub
$(DEBIAN)/control.stub: $(DEBIAN)/d-i/kernel-versions.in	\
		$(DROOT)/scripts/control-create		\
		$(DEBIAN)/control.stub.in			\
		$(DEBIAN)/changelog			\
		$(wildcard $(DEBIAN)/control.d/* $(DEBIAN)/sub-flavours/*.vars)
	for i in $(DEBIAN)/d-i/kernel-versions.in $(DEBIAN)/control.stub.in; do	\
	  new=`echo $$i | sed 's/\.in$$//'`;					\
	  cat $$i | sed -e 's/PKGVER/$(release)/g'                              \
	        -e 's/ABINUM/$(abinum)/g'                                       \
		-e 's/SRCPKGNAME/$(src_pkg_name)/g'                             \
		-e 's/=HUMAN=/$(human_arch)/g'                                    \
	  > $$new;								\
	done
	flavours="$(wildcard $(DEBIAN)/control.d/vars.* $(DEBIAN)/sub-flavours/*.vars)";\
	for i in $$flavours; do							\
	  $(SHELL) $(DROOT)/scripts/control-create $$i |				\
		sed -e 's/PKGVER/$(release)/g'                                  \
		-e 's/ABINUM/$(abinum)/g'                                       \
		-e 's/SRCPKGNAME/$(src_pkg_name)/g'                             \
		-e 's/=HUMAN=/$(human_arch)/g'                                    \
		>> $(DEBIAN)/control.stub;						\
	done
	cp $(DEBIAN)/control.stub $(DEBIAN)/control

.PHONY: debian/control
debian/control: $(DEBIAN)/control.stub
	rm -rf $(builddir)/modules $(builddir)/firmware			\
		$(builddir)/kernel-versions $(builddir)/package-list	\
		$(builddir)/$(DEBIAN)
	mkdir -p $(builddir)/modules/$(arch)/
	cp $(DEBIAN)/d-i/modules/* $(builddir)/modules/$(arch)/
	mkdir -p $(builddir)/firmware/$(arch)/
	cp $(DEBIAN)/d-i/firmware/* $(builddir)/firmware/$(arch)/
	cp $(DEBIAN)/d-i/package-list $(DEBIAN)/d-i/kernel-versions $(builddir)/
	touch $(builddir)/modules/$(arch)/kernel-image
	# kernel-wedge needs to poke around in $(DEBIAN)/
	ln -nsf $(CURDIR)/debian $(builddir)/debian

	# Some files may need to differ between architectures
	if [ -d $(DEBIAN)/d-i/modules-$(arch) ]; then			\
	    cp $(DEBIAN)/d-i/modules-$(arch)/* \
		$(builddir)/modules/$(arch)/;				\
	fi
	if [ -d $(DEBIAN)/d-i/firmware-$(arch) ]; then			\
	    cp $(DEBIAN)/d-i/firmware-$(arch)/* \
		$(builddir)/firmware/$(arch)/;				\
	fi

	# Remove unwanted stuff for this architecture
	if [ -r "$(DEBIAN)/d-i/exclude-modules.$(arch)" ]; then		\
	    (cat $(DEBIAN)/d-i/exclude-modules.$(arch);			\
	     ls $(builddir)/modules/$(arch)/) | sort | uniq -d |	\
		(cd $(builddir)/modules/$(arch)/; xargs rm -f);		\
	fi
	if [ -r "$(DEBIAN)/d-i/exclude-firmware.$(arch)" ]; then		\
	    (cat $(DEBIAN)/d-i/exclude-firmware.$(arch);			\
	     ls $(builddir)/firmware/$(arch)/) | sort | uniq -d |	\
		(cd $(builddir)/firmware/$(arch)/; xargs rm -f);	\
	fi

	# Per flavour module lists
	flavour_modules=`ls $(DEBIAN)/d-i/modules.$(arch)-* 2>/dev/null`	\
		|| true;						\
	if [ "$$flavour_modules" != "" ]; then				\
	    for flav in $$flavour_modules; do				\
		name=`echo $$flav | sed 's/.*\/modules.$(arch)-//'`;	\
		mkdir $(builddir)/modules/$(arch)-$$name;		\
		(cd $(builddir)/modules/; tar cf - `cat ../$$flav`) |	\
		    (cd $(builddir)/modules/$(arch)-$$name/; tar xf -);	\
		touch $(builddir)/modules/$(arch)-$$name/kernel-image;	\
	    done;							\
	fi
	flavour_firmware=`ls $(DEBIAN)/d-i/firmware.$(arch)-* 2>/dev/null`	\
		|| true;						\
	if [ "$$flavour_firmware" != "" ]; then				\
	    for flav in $$flavour_firmware; do				\
		name=`echo $$flav | sed 's/.*\/firmware.$(arch)-//'`;	\
		mkdir $(builddir)/firmware/$(arch)-$$name;		\
		(cd $(builddir)/firmware/; tar cf - `cat ../$$flav`) |	\
		    (cd $(builddir)/firmware/$(arch)-$$name/; tar xf -);\
		touch $(builddir)/firmware/$(arch)-$$name/kernel-image;	\
	    done;							\
	fi

	# Some files may need to differ between flavours
	flavour_module_dirs=`ls -d $(DEBIAN)/d-i/modules-$(arch)-* 2>/dev/null`\
		|| true;						\
	if [ "$$flavour_module_dirs" ]; then				\
	    for flav in $$flavour_module_dirs; do			\
		name=`echo $$flav | sed 's/.*\/modules-$(arch)-//'`;	\
		[ -d $(builddir)/modules/$(arch)-$$name ] ||		\
		    cp -a $(builddir)/modules/$(arch)			\
			modules/$(arch)-$$name;				\
		cp $$flav/* $(builddir)/modules/$(arch)-$$name/;	\
	    done;							\
	fi
	flavour_firmware_dirs=`ls -d $(DEBIAN)/d-i/firmware-$(arch)-* 2>/dev/null`\
		|| true;						\
	if [ "$$flavour_firmware_dirs" ]; then				\
	    for flav in $$flavour_firmware_dirs; do			\
		name=`echo $$flav | sed 's/.*\/firmware-$(arch)-//'`;	\
		[ -d $(builddir)/firmware/$(arch)-$$name ] ||		\
		    cp -a $(builddir)/firmware/$(arch)			\
			firmware/$(arch)-$$name;			\
		cp $$flav/* $(builddir)/firmware/$(arch)-$$name/;	\
	    done;							\
	fi

	# Remove unwanted stuff for each flavour
	flavour_exclude=`ls $(DEBIAN)/d-i/exclude-modules.$(arch)-* 2>/dev/null`\
		|| true;						\
	if [ "$$flavour_exclude" ]; then				\
	    for flav in $$flavour_exclude; do				\
		name=`echo $$flav | sed 's/.*\/exclude-modules.$(arch)-//'`;\
		[ -d $(builddir)/modules/$(arch)-$$name ] ||		\
		    cp -a $(builddir)/modules/$(arch) 			\
			$(builddir)/modules/$(arch)-$$name;		\
		(cat $$flav;						\
		 ls $(builddir)/modules/$(arch)-$$name) |		\
		 sort |	uniq -d |					\
		    (cd $(builddir)/modules/$(arch)-$$name/;		\
		     xargs rm -f);					\
	    done;							\
	fi
	flavour_exclude=`ls $(DEBIAN)/d-i/exclude-firmware.$(arch)-* 2>/dev/null`\
		|| true;						\
	if [ "$$flavour_exclude" ]; then				\
	    for flav in $$flavour_exclude; do				\
		name=`echo $$flav | sed 's/.*\/exclude-firmware.$(arch)-//'`;\
		[ -d $(builddir)/firmware/$(arch)-$$name ] ||		\
		    cp -a $(builddir)/firmware/$(arch) 			\
			$(builddir)/firmware/$(arch)-$$name;		\
		(cat $$flav;						\
